#include <cstdlib>
#include <iostream>
#include <string>
#include <math.h>
using namespace std;

float  DistanceBetween(float Ax, float Ay, float Az, float Bx, float By, float Bz);
float  DistanceBetween2(float Ax, float Ay, float Az, float Bx, float By, float Bz);
bool   SphereSphereCollision(float Ax, float Ay, float Az, float Bx, float By, float Bz, float Ar, float Br, float Sx, float Sy, float Sz);
string CollisionTest(int host, int number_of_actors, float HitSx[], float HitSy[], float HitSz[], float HitSr[], float AtkSx[], float AtkSy[], float AtkSz[], float AtkSr[], float ActSr[], float ScaleX, float ScaleY, float ScaleZ, float pScaleX, float pScaleY, float pScaleZ);
string TF(bool var);

int main()
{   
//    //data to be fed from B4A
//
//        //HitSphereActor:    0  1  2  3  4  5
//        float HitDataX[6] = {2, 2, 2, 2, 2, 2};
//        float HitDataY[6] = {2, 2, 2, 2, 2, 2};
//        float HitDataZ[6] = {2, 2, 2, 2, 2, 2};
//        float HitDataR[6] = {2, 2, 2, 2, 2, 2};
//
//        //AtkSphereActor:    0  1  2  3  4  5
//        float AtkDataX[6] = {2, 2, 2, 2, 2, 2};
//        float AtkDataY[6] = {2, 2, 2, 2, 2, 2};
//        float AtkDataZ[6] = {2, 2, 2, 2, 2, 2};
//        float AtkDataR[6] = {2, 2, 2, 2, 2, 2};
//
//        //ActSphereActor:    0  1  2  3  4  5
//        float ActDataR[6] = {2, 2, 2, 2, 2, 2}; //ActSphere X, Y, Z is the same as his HitSphere
//        
//        //Detection Scale for Potential Collisions
//        float pSclX = 1;
//        float pSclY = 1;
//        float pSclZ = 1;
//
//        //Detection Scale
//        float SclX  = 1;
//        float SclY  = 1;
//        float SclZ  = 1;        
//        
//    //end of data feed
//  
//    cout << CollisionTest(0, 6, HitDataX, HitDataY, HitDataZ, HitDataR, AtkDataX, AtkDataY, AtkDataZ, AtkDataR, ActDataR, SclX, SclY, SclZ, pSclX, pSclY, pSclZ);
//    
//    //Exit
//    int byebye;
//    cin >> byebye;
    return 0;
}



string CollisionTest(int host, int number_of_actors, float HitSx[], float HitSy[], float HitSz[], float HitSr[], float AtkSx[], float AtkSy[], float AtkSz[], float AtkSr[], float ActSr[], float ScaleX, float ScaleY, float ScaleZ, float pScaleX, float pScaleY, float pScaleZ)
{
    //Potential, Body, Aggression, Victim
    string CollisionMatrix;

    bool PotentialCollision[number_of_actors][number_of_actors];
    bool BodyBodyCollision[number_of_actors][number_of_actors];
    bool AttkBodyCollision[number_of_actors][number_of_actors];
    bool BodyAttkCollision[number_of_actors][number_of_actors];    

    for (int guest = host + 1; guest < number_of_actors; guest++)
    {
        if (SphereSphereCollision(HitSx[host], HitSy[host], HitSz[host], ActSr[host], HitSx[guest], HitSy[guest], HitSz[guest], ActSr[guest], pScaleX, pScaleY, pScaleZ))
        {
             PotentialCollision[host][guest] = true;
             PotentialCollision[guest][host] = true;
             
             BodyBodyCollision[host][guest]  = SphereSphereCollision(HitSx[host], HitSy[host], HitSz[host], HitSr[host], HitSx[guest], HitSy[guest], HitSz[guest], HitSr[guest], ScaleX, ScaleY, ScaleZ);
             BodyBodyCollision[guest][host]  = BodyBodyCollision[host][guest];
             
             AttkBodyCollision[host][guest]  = SphereSphereCollision(AtkSx[host], AtkSy[host], AtkSz[host], AtkSr[host], HitSx[guest], HitSy[guest], HitSz[guest], HitSr[guest], ScaleX, ScaleY, ScaleZ);
             AttkBodyCollision[guest][host]  = SphereSphereCollision(AtkSx[guest], AtkSy[guest], AtkSz[guest], AtkSr[guest], HitSx[host], HitSy[host], HitSz[host], HitSr[host], ScaleX, ScaleY, ScaleZ);             

             CollisionMatrix = CollisionMatrix + TF(BodyBodyCollision[host][guest]) + TF(AttkBodyCollision[host][guest]) + TF(AttkBodyCollision[guest][host]) + "\n";
        }               
        else
        {
             CollisionMatrix = CollisionMatrix + "000\n";
        }
    }

    return CollisionMatrix; //returns the array of results
}


string TF(bool var){
    if (var){
       return "1";}
    else{
       return "0";}}


bool SphereSphereCollision(float Ax, float Ay, float Az, float Bx, float By, float Bz, float Ar, float Br, float Sx, float Sy, float Sz){    
    if (DistanceBetween2(Ax * Sx, Ay * Sy, Az * Sz, Bx * Sx, By * Sy, Bz * Sz) <= ((Ar + Br) * (Ar + Br))){  
        return true;}
    else{
        return false;}}


float DistanceBetween2(float Ax, float Ay, float Az, float Bx, float By, float Bz){
    return ((Bx - Ax) * (Bx - Ax)) + ((By - Ay) * (By - Ay)) + ((Bz - Az) * (Bz - Az));}


float DistanceBetween(float Ax, float Ay, float Az, float Bx, float By, float Bz){
    return sqrt(((Bx - Ax) * (Bx - Ax)) + ((By - Ay) * (By - Ay)) + ((Bz - Az) * (Bz - Az)));}
